%global debug_package %{nil}

Name:           oraclelinux-release-el8
Version:        1.0
Release:        30%{dist}
Summary:        Oracle Linux yum repository configuration

Group:          System Environment
License:        GPLv2

Source0:        oraclelinux-release-el8-1.0.tgz
Source1:        LICENSE
Source2:        uek-ol8.repo
Source3:        virt-ol8.repo
Source4:        uek-ol8.repo.aarch64
Patch0:         aarch64_oracle-linux.patch



BuildArch:     x86_64 aarch64
Requires:      grep
Requires:      sed
Requires:      curl


%description
This package contains the  Oracle Linux  yum repository configuration.

%prep
%setup -q

%if %{?_host_cpu} == aarch64
%patch0 -p1
%endif


%build


%install
rm -rf $RPM_BUILD_ROOT


install -m 755 -d $RPM_BUILD_ROOT/usr/share/doc/%{name}/
install -dm 755 $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d
install -pm 644 %{_builddir}/%{name}-%{version}/oracle-linux-ol8.repo $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d
install -m 755 %{SOURCE1}  $RPM_BUILD_ROOT%{_datadir}/doc/%{name}
%if %{?_host_cpu} == x86_64
install -pm 644 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d
%endif
install -pm 644 %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d
%if %{?_host_cpu} == aarch64
install -pm 644 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d/uek-ol8.repo
%endif


%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%dir %{_datadir}/doc/%{name}
%{_datadir}/doc/%{name}/*
%config(noreplace) /etc/yum.repos.d/*


%post

instance_command='curl --max-time 1 -q -f http://169.254.169.254/opc/v2/instance/'
if [ -d /etc/yum/vars ]; then
  yumvars_dir=/etc/yum/vars
else
  if [ ! -d /etc/dnf/vars ]; then
    mkdir -p /etc/dnf/vars
    chmod 755 /etc/dnf/vars
  fi
  yumvars_dir=/etc/dnf/vars
fi

if [ ! -f $yumvars_dir/ociregion ]; then
(http_proxy="";curl --max-time 1 -q -f http://169.254.169.254/opc/v2/instance/ -H "Authorization: Bearer Oracle" > /dev/null 2>&1)
 if [ $? != 0 ]; then
   echo > $yumvars_dir/ociregion
   echo oracle.com > $yumvars_dir/ocidomain
 else
  instance_region=$(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" -s 2> /dev/null | grep regionIdentifier | awk -F\: '{print $2}' | sed -e 's/\"//g' -e 's/ //g' -e 's/,//g')
  instance_domain=$(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" -s 2> /dev/null | grep realmDomainComponent | awk -F: '{print $2}' | sed -e 's/"//g' -e 's/,//g' -e 's/^\s//g')
  instance_realm=$(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" -s 2>/dev/null | grep realmKey | awk -F: '{print $2}' | sed -e 's/"//g' -e 's/,//g' -e 's/^\s//g')
  if [ -z "$instance_region" -o -z "$instance_domain" ]; then
    echo > $yumvars_dir/ociregion
    echo oracle.com > $yumvars_dir/ocidomain
  else
    if curl -sfm 25 http://yum-${instance_region}.oracle.com &> /dev/null || curl -sfm 25 https://yum.${instance_region}.oci.${instance_domain} &> /dev/null; then
        echo oci.$instance_domain > $yumvars_dir/ocidomain
        echo ".$instance_region" > $yumvars_dir/ociregion
    else
        echo > $yumvars_dir/ociregion
        echo oracle.com > $yumvars_dir/ocidomain
     fi
  fi
 fi
fi

if [ ! -f $yumvars_dir/ocidomain ]; then
   (http_proxy="";$instance_command -H "Authorization: Bearer Oracle" > /dev/null 2>&1)
    if [ $? != 0 ]; then
      echo oracle.com > $yumvars_dir/ocidomain
    else
     instance_domain=$(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" -s 2> /dev/null | grep realmDomainComponent | awk -F: '{print $2}' | sed -e 's/"//g' -e 's/,//g' -e 's/^\s//g')
     instance_realm=$(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" -s 2>/dev/null | grep realmKey | awk -F: '{print $2}' | sed -e 's/"//g' -e 's/,//g' -e 's/^\s//g')
       if [ -z $instance_domain ]; then
         echo oracle.com > $yumvars_dir/ocidomain
       elif [[ -n $instance_realm ]]; then
          echo oci.$instance_domain > $yumvars_dir/ocidomain
       else
          echo oracle.com > $yumvars_dir/ocidomain
       fi
    fi
fi


%changelog
* Wed Apr 05 2023 Alex Burmashev <alexander.burmashev@oracle.com> 1.0-30
- Enabled developer preview repositories [35260783]

* Fri Mar 17 2023 Alex Burmashev <alexander.burmashev@oracle.com> 1.0-29
- Update post scripts to support new self-service DNS hostnames [JIRA: OLDIS-22726]

* Tue Nov  8 2022 Keshav Sharma <keshav.sharma@oracle.com> 1.0-28
- Added 8.7 repositories [ Orabug: 34662141 ]
- Remove developer preview repositories

* Thu Oct 27 2022 Keshav Sharma <keshav.sharma@oracle.com> 1.0-27
- Revert enabling of UEKR7 repositories by default [ Orabug: 34743522].

* Tue Oct  4 2022 Keshav Sharma <keshav.sharma@oracle.com> 1.0-26
- Enable UEKR7 repositories by default [ Orabug: 34662093].
- Added developer preview repositories [ Orabug: 34662124]

* Thu Jun 23 2022 Keshav Sharma <keshav.sharma@oracle.com> 1.0-25
- Added UEKR7 repositories.
- Added leapp repository [ Orabug: 34325339]

* Wed Jun 15 2022 Keshav Sharma <keshav.sharma@oracle.com> 1.0-24
- Added Modified RHCK repository for x86_64.

* Tue May 10 2022 Keshav Sharma <keshav.sharma@oracle.com> 1.0-23
- Added 8.6 repositories [Orabug: 34112332]

* Mon Mar  7 2022 Keshav Sharma <keshav.sharma@oracle.com> 1.0-22
- Added 8.4 security validation repository for aarch64 [Orabug: 33931697]

* Wed Dec  8 2021 Keshav Sharma <keshav.sharma@oracle.com> 1.0-21
- Added 8.4 security validation repository

* Wed Nov 10 2021 Keshav Sharma <keshav.sharma@oracle.com> 1.0-20
- Added 8.5 repositories [Orabug: 33556144]

* Tue May 18 2021 Keshav Sharma <keshav.sharma@oracle.com> 1.0-19
- Added virt-ol8.repo for kvm appstream repository.
- Added addons repository for aarch64

* Tue May 18 2021 Keshav Sharma <keshav.sharma@oracle.com> 1.0-18
- Added 8.4 repositories [Orabug: 32806802]

* Tue Apr 27 2021 Keshav Sharma <keshav.sharma@oracle.com> 1.0-17
- Added 8.4 beta repositories [Orabug: 32806791]

* Thu Jan 28 2021 Keshav Sharma <keshav.sharma@oracle.com> 1.0-16.0.1
- Add ocidomain as yum variable [ OraBug: 31840501]

* Mon Dec 21 2020 Keshav Sharma <keshav.sharma@oracle.com> 1.0-15
- Added distro builder repository

* Tue Nov  3 2020 Keshav Sharma <keshav.sharma@oracle.com> 1.0-14
- Added 8.3 base repository [Orabug: 32002214]
- Revert patch for bug 32002203 to remove beta repositories

* Tue Oct 13 2020 Keshav Sharma <keshav.sharma@oracle.com> 1.0-13
- Added 8.3 beta repositories [Orabug: 32002203]

* Fri Jul 17 2020 Keshav Sharma <keshav.sharma@oracle.com> 1.0-12
- Use IMDS v2 for OCI.

* Wed Apr 15 2020 Keshav Sharma <keshav.sharma@oracle.com> 1.0-11
- Added 8.2 base repository [Orabug: 31056571]
- Revert patch for bug 31056604 to remove beta repositories

* Wed Apr 15 2020 Keshav Sharma <keshav.sharma@oracle.com> 1.0-10
- Added 8.2 beta repositories [Orabug: 31056604]

* Tue Mar 24 2020 Keshav Sharma <keshav.sharma@oracle.com> 1.0-9
- Added UEK repo file to include UEK6 entries [Orabug: 31074762]

* Wed Jan 15 2020 Tianyue Lan <tianyue.lan@oracle.com> 1.0-8
- roll back the changes for orabug 30379164.

* Wed Nov 06 2019 Keshav Sharma <keshav.sharma@oracle.com> 1.0-7
- Removed 8.1 Beta repositories
- Added 8.1 base repository [Orabug: 30258719]

* Mon Oct 07 2019 Tianyue Lan <tianyue.lan@oracle.com> 1.0-6
- Requires yum [Orabug: 30379164]

* Fri Sep 20 2019 Keshav Sharma <keshav.sharma@oracle.com> 1.0-5
- Updated repo file to include 8.1 beta repos [Orabug: 30295382]

* Tue Jul 09 2019 Keshav Sharma <keshav.sharma@oracle.com> 1.0-4
- Fixed repository name [ orabug 30024377]

* Mon Jun 24 2019 Keshav Sharma <keshav.sharma@oracle.com> 1.0-3
- Update repository information for GA release [ orabug 29859318]

* Thu May 30 2019 Keshav Sharma <keshav.sharma@oracle.com> 1.0-2
- Update repository information for GA release [ orabug 29837423]

* Tue Mar 19 2019 Keshav Sharma <keshav.sharma@oracle.com> 1.0-1
- Intial version

